
//#include "stdafx.h"
#include "c1541.h"
#include "term.h"


extern char C64_ASCII(char);
extern void C64_ASCII(char*);
extern c1541_error FILE_NOT_FOUND;
//extern c1541_error WRITE_ERROR;


str FileTypes[8] =
{
	str(".del"), str(".seq"), str(".prg"),
	str(".usr"), str(".rel"), str(""),
	str(""), str("")
};


c1541_extended::c1541_extended()
{
	int c=16;
	while (c-->0) f_buffer[c] = NULL;

	diskimage_path = str("");
}

c1541_extended::~c1541_extended()
{
	int c=16;
	while (c-->0) delete f_buffer[c];
//	filefind.Close();	BRAUCHE NICHT
}

void c1541_extended::Reset(byte* _diskimage)
{
	int c=16;
	while (c-->0)
	{ 
		delete f_buffer[c];
		f_buffer[c] = NULL;
	}
//	filefind.Close();		BRAUCHE NICHT

	c1541::Reset(_diskimage);
}

void c1541_extended::Exception(c1541_error* code)
{
	delete f_buffer[secundar_addr];
	f_buffer[secundar_addr] = NULL;

	c1541::Exception(code);
}

void c1541_extended::OpenFile()
{
	/*			BRAUCHE NICHT

	term << "\n\n ***OPEN FILE**";
	if (!extended_flag)
	{
		c1541::OpenFile();
		return;
	}

	if (f_buffer[secundar_addr] == NULL)
		f_buffer[secundar_addr] = new byte[DISK_SIZE];

	f_access[secundar_addr] = file_access;
	f_type[secundar_addr] = file_type;
	f_pos[secundar_addr] = 0;
	
	if (file_access == FILE_ACCESS_READ)
	{
		secundar->disk_io_read = TRUE;

		str x = GetFilePath();
		term  << "\n FILENAME = " << x.Addr();
		CFileFind find;
		if (! find.FindFile(x.ch())) throw &FILE_NOT_FOUND;
		find.FindNextFile();
		CString fn = find.GetFilePath();

		try
		{
			CFile cf(fn.GetBuffer(0),CFile::shareDenyWrite|CFile::modeRead);
			f_size[secundar_addr] = (int) cf.Read(f_buffer[secundar_addr],DISK_SIZE);
			cf.Close();
		}
		catch(CFileException* e)
		{
			term <<"\n\nFile could not be opened " << e->m_cause << "\n";

			throw &FILE_NOT_FOUND;
		}
	}
	else
		secundar->disk_io_read = FALSE;
	*/
}

void c1541_extended::CloseFile()
{
	/*		BRAUCHE NICHT

	term << "\n\n *** CLOSE FILE ****";
	if (!extended_flag)
	{
		c1541::CloseFile();
		return;
	}

	if (secundar->directory_mode)
	{
		term << "   ** DIR_CLOSE **";
//		filefind.Close();	BRAUCHE NICHT
		return;
	}

	if (! secundar->disk_io_read)
	{
		int filemode = 0;
		if (f_access[secundar_addr] == FILE_ACCESS_APPEND)
			filemode = CFile::modeNoTruncate;

		try
		{
			CFile cf(GetFilePath().ch(),filemode|CFile::modeCreate|CFile::shareDenyWrite|CFile::modeWrite);
			cf.SeekToEnd();
			cf.Write(f_buffer[secundar_addr],f_pos[secundar_addr]);
			cf.Close();
		}
		catch(CFileException* e)
		{

			term << "\n ERROR: " << GetFilePath().ch() << " could not be saved, error = " << e->m_cause << "\n";

	//		delete f_buffer[secundar_addr];
			//throw &WRITE_ERROR;
		}
	}

	delete f_buffer[secundar_addr];
	f_buffer[secundar_addr] = NULL;

	*/
}

long c1541_extended::ReadDiskIO()
{
	if (!extended_flag) return c1541::ReadDiskIO();

	if (f_pos[secundar_addr] >= f_size[secundar_addr]) return EOF_FLAG;

	long end_flag = 0;
	if (f_pos[secundar_addr] == (f_size[secundar_addr]-1))
		end_flag = EOF_FLAG;

	return f_buffer[secundar_addr][f_pos[secundar_addr]++] | end_flag;
}

void c1541_extended::WriteDiskIO(long date)
{
	if (!extended_flag)
	{
		c1541::WriteDiskIO(date);
		return;
	}

	if (f_pos[secundar_addr] >= DISK_SIZE) return;

	f_buffer[secundar_addr][f_pos[secundar_addr]++] = (byte) date;
}
/*
byte* c1541_extended::BoostWriteBus(long& length)
{
	if (!extended_flag) return c1541::BoostWriteBus(length);

	length = f_size[secundar_addr];
	byte* buffer = f_buffer[secundar_addr];
	f_buffer[secundar_addr] = NULL;
	return buffer;
}*/
/*
void c1541_extended::BoostReadBus(byte* buffer,long length)
{
	if (!extended_flag)
	{
		c1541::BoostReadBus(buffer,length);
		return;
	}

	long c = -1;
	while (++c < length)
		WriteDiskIO(buffer[c]);
}*/


str c1541_extended::GetFilePath()
{
	str a = diskimage_path;
	C64_ASCII(filename);
	return a + filename + FileTypes[f_type[secundar_addr]];
}

int c1541_extended::GetFileType(char* path)
{
	str f = path;
	(f >> str_end) <= 4;

	//f.KleinSchreibung();		//  ACHTUNG kommentiert, da absturz !?

	term  << "\n Die Fileendung lautet " << f.ch();
	
	int c = 5;
	while (c-->0)
		if (f == FileTypes[c])
			return c;
	return 0;
}

void c1541_extended::OpenDirectory()
{
	/*		BRAUCHE NICHT

	c1541::OpenDirectory();
	if (!extended_flag) return;
	
	str b = diskimage_path;
	if (! filefind.FindFile((b+str(directory_filename)).ch()) )
		directory_end = TRUE;

	directory_last_file = FALSE;
	*/
}

void c1541_extended::DirectoryMode_WriteEntry()
{
	/*		BRAUCHE NICHT

	if (!extended_flag)
	{
		c1541::DirectoryMode_WriteEntry();
		return;
	}
	
	if (directory_last_file || directory_end)
	{
		directory_end = TRUE;
		return;
	}

	if (! filefind.FindNextFile()) directory_last_file = TRUE;

	//{
	int const mod = BLOCK_SIZE - BLOCK_HEADER_SIZE;
	int len = filefind.GetLength() / mod;
	if (len % mod > 0) len ++;

	DirectoryMode_WriteBasicLineNumber(len);
		
	CString fn = filefind.GetFileName();

	int c = fn.GetLength();
	int d = c;
	while (c-->0) dir_buffer[dir_buffer_pos+c] = C64_ASCII(fn.GetAt(c));
	dir_buffer_pos += d;
	*/


	/*}
	else
	{
	//	filefind.Close();
		directory_end = TRUE;
	}*/

/*	while (1)
	{
//		if (filefind.FindNextFile())
//		{
		//	if (1 GetC64FileType(fn)>=0)	
		//	{
				int const mod = BLOCK_SIZE - BLOCK_HEADER_SIZE;
				int len = filefind.GetLength() / mod;
				if (len % mod > 0) len ++;

				DirectoryMode_WriteBasicLineNumber(len);
		
				CString fn = filefind.GetFileName();

				int dpos = dir_buffer_pos;

				dir_buffer[dpos] = '"';

				int fnlen = fn.GetLength();
				int c = fnlen;
				if (c>=16) c = 16;
				dir_buffer[dir_buffer_pos+c+1] = '"';
				while (c-->0) dir_buffer[dir_buffer_pos+c] = C64_ASCII(fn.GetAt(c));
			
				c=3;
				while (c-->0) dir_buffer[dpos+DIR_EINRUCKEN_FILETYPE+c] = C64_ASCII(fn.GetAt(fnlen-3+c));
			
			//	break;
		//	}
		}
		else
		{
			//filefind.Close(); IST IN CLOSE_FILE
			directory_end = TRUE;
		//	break;
		}
//	}*/
}




/*
void Load(char* filename,byte* addr,long size)
{
	try
	{
		CFile* file = new CFile(filename,CFile::shareDenyWrite|CFile::modeRead);
		file->Read(addr,size);
		file->Close();
		delete file;
	}
	catch( CFileException* e)
	{
//		delete file;
		term << "\n" <<"\nFile could not be opened " << e->m_cause << "\n";
		throw READ_ERROR;
	}
	
}

void Save(char* filename,byte* addr,long size)
{
	try
	{
		CFile* file = new CFile(filename,CFile::modeWrite|CFile::modeCreate);
		file->Write(addr,size);
		file->Close();
		delete file;
	}
	catch( CFileException* e )
	{
//		delete file;
        term << "\nFile could not be saved " << e->m_cause << "\n";
		throw WRITE_ERROR;
	}

}
*/



c1541_diskimage::c1541_diskimage()
{
	diskimage = 0;
}


void c1541_diskimage::RemoveDisk()
{
	//if (! diskimage) return;

	if (!extended_flag) SaveDiskImage();
	delete diskimage;
	diskimage = NULL;
}

void c1541_diskimage::InsertDisk(char* fn,bool extended)
{
	RemoveDisk();

	diskimage_path = fn;
	diskimage_path.ch();

	extended_flag = extended;

	//try
	//{
	if (!extended_flag) LoadDiskImage();
	/*}
	catch (pc_file_error code)
	{
		term << "\n pc file error = " << code.code;

		delete diskimage;
		diskimage = 0;
		return;
	}*/

	Reset(diskimage);
	//	diskimage_changed = TRUE;  //provisorisch!!
}

void c1541_diskimage::SaveDiskImage()
{
	if ( !diskimage ) return;

	/*		BRAUCHE NICHT

	unsigned short start_addr = 0x1000;
	if (ram_changed)
	{
		try
		{
			CFile file("RAM_C1541.prg",CFile::modeWrite|CFile::modeCreate);
			file.Write(&start_addr,2);
			file.Write(ram,C1541_RAM_SIZE);
			file.Close();
			ram_changed = false;
		}
		catch( CFileException* e )
		{
	      term << "\nDiskimage could not be saved " << e->m_cause << "\n";
//		throw WRITE_ERROR;
		}
	}

	*/

	if (!diskimage_changed) return;
	term << "\n Saving_Diskimage";
	{
		std::ofstream file(diskimage_path.ch(),std::ofstream::binary);
		file.write((char*)diskimage,DISK_SIZE);
		file.close();
		diskimage_changed = false;
	}

	/*   ALT	BRAUCHE NICHT
	try
	{
		CFile file(diskimage_path.ch(),CFile::modeWrite|CFile::modeCreate);
		file.Write(diskimage,DISK_SIZE);
		file.Close();
		diskimage_changed = false;
	}
	catch( CFileException* e )
	{
        term << "\nFile could not be saved " << e->m_cause << "\n";
//		throw WRITE_ERROR;
	}
	*/
}

void c1541_diskimage::LoadDiskImage()
{
	diskimage = new byte[DISK_SIZE];

	term << "\n versuch load diskimage: " << diskimage_path.ch();

	
		std::ifstream file(diskimage_path.ch(), std::ios::binary);
		
		if (! file.fail())
		{
			file.read((char*) diskimage,DISK_SIZE);
			file.close();
		}
		else
		{
			delete diskimage;
			diskimage = NULL;
			term << "\n" <<"\nFile could not be opened \n";
		}

/*		ALT		BRAUCHE NICHT
	try
	{
		CFile file(diskimage_path.ch(),CFile::shareDenyWrite|CFile::modeRead);
		file.Read(diskimage,DISK_SIZE);
		file.Close();
	}
	catch( CFileException* e)
	{
		delete diskimage;
		diskimage = NULL;
		term << "\n" <<"\nFile could not be opened " << e->m_cause << "\n";
		//throw READ_ERROR;
	}
	*/
}


bool c1541_diskimage::UnpackDiskImage(c1541_diskimage* dest_drv)
{
	if ( !dest_drv->extended_flag || extended_flag || !diskimage ) return false;
	Directory dir(diskimage);
	byte* buffer = new byte[DISK_SIZE];
	bool alright = true;

	while (dir.GetNextFileEntry() >= 0)
	{
		if (dir.TestValidFileEntry() && (dir.GetFileType() & FILETYPE_CLOSED_FLAG) )
		{
			
			DiskIO disk(dir.GetFilePosition(),diskimage);

			long c = 0;
			while (1)
			{
				 long x = disk.Read();
				 if (x < 0) break;
				 buffer[c++] = (byte) x;
			}

			char name[FILE_ENTRY_FILENAME_SIZE+1];
			dir.CopyFileName(name);
			C64_ASCII(name);
			str fn = str(dest_drv->diskimage_path) + name + FileTypes[dir.GetFileType() & FILE_TYPE_BITMASK];


			std::ofstream file(fn.ch(),std::ofstream::binary);
			file.write((char*) buffer,c);
			file.close();

		/*	ALT		BRAUCHE NICHT
			try
			{
				CFile file(fn.ch(),CFile::modeWrite|CFile::modeCreate);
				file.Write(buffer,c);
				file.Close();
			}
			catch (CFileException*)
			{
				term << "\nProbleme bei File: " << fn.ch();
				alright = false;
			}
			*/
		}
	}
	return alright;
}

bool c1541_diskimage::AddFileToDiskimage(char* filepath)
{
	if ( !diskimage || extended_flag ) return false;

	term << "\n Filepath = " << filepath;
	str filename = filepath;
	!(filename >> str_end) << "\\" >= ".";
	term << "\n " << filename.ch() ;//<< "   " << fileending.ch();

	//try
	{
		std::ifstream file(filepath, std::ios::binary);
		
		if (file.fail())
		{
			term << "\n" <<"\nFile could not be opened \n";
			return false;
		}

		file.seekg(0,std::ios::end);
		int len = file.tellg();
		file.seekg(0,std::ios::beg);

		//CFile file(filepath,CFile::modeRead);
		char* buffer = new char[DISK_SIZE];
		file.read(buffer,DISK_SIZE);
		file.close();

		Directory dir(diskimage);
			filename.C64Schreibung();
			char* fn = filename.ch();
			if (dir.SearchFileEntry(fn)) dir.DeleteFile();
			else dir.SearchFileEntry();
			dir.SetFileName(fn);
		dir.EnterFilePosition();
		dir.SetFileType(GetFileType(filepath));

		DiskIO diskio(dir.GetFilePosition(),diskimage);
		int c = 0;
		while(len-->0)
			diskio.Write((byte) buffer[c++]);
		diskio.WriteFileEnd();

		dir.CloseFile();
		diskimage_changed = true;
		delete buffer;
	}
	//catch (CFileException*)
	//{
	//	term << "\n ERROR Add To Diskimage.";
	//}

	return true;
}

void c1541_diskimage::NewFormatedDisk(str filepath)
{
	RemoveDisk();
	diskimage = new byte[DISK_SIZE];
	Reset(diskimage);
	
	byte* bam = diskimage+LOGICAL_BAM_POSITION;
	bam[0] = 18;
	bam[1] = 1;
	bam[2] = 0x41;
	int c = 144-3; while (c-->0) bam[3+c] = 0;
	c = 512-144; while (c-->0) bam[144+c] = FILENAME_FILL_BYTE;
	bam[165] = '2';
	bam[166] = 'A';
	c = 221-171; while (c-->0) bam[171+c] = 0;

	BAM bamop(bam);
	c = 0;
	while (c < DISK_SIZE)
	{
		bamop.DeAllocBlock(c);
		c += 0x100;
	}
	bamop.AllocateBlock(LOGICAL_BAM_POSITION);
	bamop.AllocateBlock(LOGICAL_BAM_POSITION+0x100);

	bam[256] = 0;
	bam[257] = 255;
	c = 2;
	while (c < 256)
	{
		bam[256+c] = 0;
		c += 16;
	}

	diskimage_changed = TRUE;
	extended_flag = FALSE;
	diskimage_path = filepath;
}

void c1541_diskimage::clrdiskimage()
{
	char* sst = "a               ";

	int d = DISK_SIZE / 16;
	while (d-->0)
	{
		int c = 16;
		while (c-->0)
		{
			diskimage[d*16+c] = sst[c];
		}
	}
}

void c1541_diskimage::SetDiskimageChanged()
{
	diskimage_changed = TRUE;
}


char c1541_extended::C64_to_PC_ASCII(char ch)
{
	unsigned char x = (unsigned char) ch;
	
	if (x >= 192 && x <= 223) x -= 96;
	if (x >= 224 && x <= 254) x -= 64;
	
	if ((x >= 'a' && x <= 'z') || (x >= 'A' && x <= 'Z')) x ^= 0x20;
	if (x == 8) x = 20;
	if (x == 9) x = 0xfe;

	if (x < 0x20 && x != 13) x = ILLEGAL_CHAR;
	return x;
}

char c1541_extended::C64_ASCII(char ch)
{
	ch = C64_to_PC_ASCII(ch);

	switch(ch)
	{
		case 92: ch = ILLEGAL_CHAR; break; //back-slash
		case '/': ch = ILLEGAL_CHAR; break;
		case ':': ch = ILLEGAL_CHAR; break;
		//case '': ch = ILLEGAL_CHAR; break; kleines x hochgestellt
		case '?': ch = ILLEGAL_CHAR; break;
		case '"': ch = ILLEGAL_CHAR; break;
		case '<': ch = ILLEGAL_CHAR; break;
		case '>': ch = ILLEGAL_CHAR; break;
		case '|': ch = ILLEGAL_CHAR; break;
	}
	return ch;
}

void c1541_extended::C64_ASCII(char* txt)
{
	while (*txt)
	{
		*txt = C64_ASCII(*txt);
		txt++;
	}
}



/*
	return true;
}

			ListenTalk(DEVICE_FLAG_LISTEN);
			SecundarListen(SECUNDAR_OPEN_FILE+2);
			
			str fn = dir.GetFileNameStr();
	//ALLES BLDSINN!!!		!!!fn += "," + dir.GetFileTypeStr() + ",R";
	//NATRLICH GLEICH MIT DISKIO WIE UNTEN.
			fn.Serialize((&WriteBus)());
			UnListen();

			ListenTalk(DEVICE_FLAG_TALK);
			SecundarListen(SECUNDAR_NORMAL+2);
			long len;
			byte* buffer = BoostWriteBus(len);

			CFile file(GetFilePath().ch()
			
*/




/*
DiskImageFiling::DiskImageFileing()
{
	buffer = new byte[DISK_SIZE];
}

DiskImageFileing::SetDiskImage(byte* X)
{
	Directory::SetDiskImage(X);
}

NUMBER_OF_FILETYPES = 5;

str FileTypes[8] =
{
	str(".del"), str(".seq"), str(".prg"),
	str(".usr"), str(".rel"), str("");
	str(""), str("");
};


BOOL DiskImageFileing::WriteFileToDiskImage(char* path)
{

	str a(path);
	str file_ending = (a>>str_end)<=4;
	str file_name = (!(a>>str_end) << "\\") >= ".";

	long ft = NUMBER_OF_FILETYPES;
	while (ft-->0)
		if (file_ending == FileTypes[c]) break;

	if (ft<0) return FALSE;


	Open(filename,CFile::shareDenyWrite|CFile::modeRead);
	UINT length = Read(buffer,DISK_SIZE);
	Close();


	SearchFileEntry();
	SetFilename(file_name.ch());
	SetFileType(ft);

	DiskIO disk(GetFilePosition(),diskimage);

	long c = 0;
	while (c < length) disk.Write(buffer[c++]);

	disk.WriteFileEnd();
}




void DiskImageFileing::WriteFile(char* filename)
{


	Open(filename,CFile::modeWrite|CFile::modeCreate);

*/


